#include "openssl/ssl.h"
#include "openssl/crypto.h"


#include <com_test_ssl_mySSL.h>
#include <android/log.h>

static int g_sock;
static SSL *g_ssl = NULL;
static SSL_CTX * g_ssl_ctx = NULL;

/*
 * Class:     com_test_ssl_mySSL
 * Method:    mySSLerrorstring
 * Signature: ()V
 */
JNIEXPORT void JNICALL Java_com_test_ssl_mySSL_mySSLerrorstring
  (JNIEnv *env, jclass c)
{
	//SSL_load_error_string();
	__android_log_print(ANDROID_LOG_DEBUG, "mySSL:", "call errorstring...");
}

/*
 * Class:     com_test_ssl_mySSL
 * Method:    mySSLwrite
 * Signature: ([BI)I
 */
JNIEXPORT jint JNICALL Java_com_test_ssl_mySSL_mySSLwrite
  (JNIEnv *env, jclass c, jbyteArray buffer, jint length)
{
	__android_log_print(ANDROID_LOG_DEBUG, "mySSL:", "call write...");
	jint result_write = 0;
	/*jbyte *data = NULL;

	data = (*env)->GetByteArrayElements(env,buffer,NULL);
	if(data == NULL)
	{
		__android_log_print(ANDROID_LOG_DEBUG, "mySSL:", "C type Array change failed...");
	}

	result_write = SSL_write(g_ssl, data, length);
	(*env)->ReleaseByteArrayElements(env,buffer,data,0);*/

	return result_write;
}

/*
 * Class:     com_test_ssl_mySSL
 * Method:    mySSLread
 * Signature: ([BI)I
 */
JNIEXPORT jint JNICALL Java_com_test_ssl_mySSL_mySSLread
  (JNIEnv *env, jclass c, jbyteArray buffer, jint length)
{
	__android_log_print(ANDROID_LOG_DEBUG, "mySSL:", "call write...");
	jint result_read = 0;
	/*jbyte *data = NULL;

	data = (*env)->GetByteArrayElements(env,buffer,NULL);
	if(data == NULL)
	{
		__android_log_print(ANDROID_LOG_DEBUG, "mySSL:", "C type Array change failed...");
	}

	result_read = SSL_read(g_ssl, data, length);
	(*env)->ReleaseByteArrayElements(env,buffer,data,0);*/

	return result_read;
}

/*
 * Class:     com_test_ssl_mySSL
 * Method:    mySSLgeterror
 * Signature: (I)I
 */
JNIEXPORT jint JNICALL Java_com_test_ssl_mySSL_mySSLgeterror
  (JNIEnv *env, jclass c, jint error)
{
	__android_log_print(ANDROID_LOG_DEBUG, "mySSL:", "call geterror...");
	return 0;//SSL_get_error(g_ssl, error);
}

/*
 * Class:     com_test_ssl_mySSL
 * Method:    mySSLpending
 * Signature: ()I
 */
JNIEXPORT jint JNICALL Java_com_test_ssl_mySSL_mySSLpending
  (JNIEnv *env, jclass c)
{
	__android_log_print(ANDROID_LOG_DEBUG, "mySSL:", "call pending...");
	return 0;//SSL_pending(g_ssl);
}

/*
 * Class:     com_test_ssl_mySSL
 * Method:    mySSLinit
 * Signature: ()V
 */
JNIEXPORT void JNICALL Java_com_test_ssl_mySSL_mySSLinit
  (JNIEnv *env, jclass c)
{
	//SSL_library_init();
	__android_log_print(ANDROID_LOG_DEBUG, "mySSL:", "call init...");
}

/*
 * Class:     com_test_ssl_mySSL
 * Method:    mySSLconnect
 * Signature: (Ljava/net/Socket;)Z
 */
JNIEXPORT jboolean JNICALL Java_com_test_ssl_mySSL_mySSLconnect
  (JNIEnv *env, jclass c, jobject sock)
{
	__android_log_print(ANDROID_LOG_DEBUG, "mySSL:", "connect into...");

	/*g_sock = sock;

	int err;
	g_ssl_ctx = SSL_CTX_new(TLSv1_client_method());

	if (g_ssl_ctx == NULL)
	{
		__android_log_print(ANDROID_LOG_ERROR, "mySSL:", "tcp_tls_connect: SSL_CTX_new() failed to create TLS v1.0 context");
		goto fail;
	}

	SSL_CTX_set_options(g_ssl_ctx, SSL_OP_ALL);

	g_ssl = SSL_new(g_ssl_ctx);
	if (g_ssl == NULL)
	{
		__android_log_print(ANDROID_LOG_ERROR, "mySSL:", "tcp_tls_connect: SSL_new() failed");
		goto fail;
	}

	if (SSL_set_fd(g_ssl, g_sock) < 1)
	{
		__android_log_print(ANDROID_LOG_ERROR, "mySSL:", "tcp_tls_connect: SSL_set_fd() failed");
		goto fail;
	}

	do
	{
		err = SSL_connect(g_ssl);
	}
	while (SSL_get_error(g_ssl, err) == SSL_ERROR_WANT_READ);

	if (err < 0)
	{
		__android_log_print(ANDROID_LOG_ERROR, "mySSL:", "last error...");
		goto fail;
	}
	__android_log_print(ANDROID_LOG_DEBUG, "mySSL:", "connect OK...");

	return 1;

	fail:

	if (g_ssl)
		SSL_free(g_ssl);
	if (g_ssl_ctx)
		SSL_CTX_free(g_ssl_ctx);

	g_ssl = NULL;
	g_ssl_ctx = NULL;

	__android_log_print(ANDROID_LOG_DEBUG, "mySSL:", "connect failed...");*/
	return 0;
}

/*
 * Class:     com_test_ssl_mySSL
 * Method:    mySSLtlsgetserverpubkey
 * Signature: ([B)Z
 */
JNIEXPORT jboolean JNICALL Java_com_test_ssl_mySSL_mySSLtlsgetserverpubkey
  (JNIEnv *env, jclass c, jbyteArray data)
{
	__android_log_print(ANDROID_LOG_DEBUG, "mySSL:", "tls into...");
	//jbyte  STREAM  ؾ    ...

	//jbyte *s = NULL; 
	//s = (*env)->GetByteArrayElements(env, data, NULL);

	//X509 *cert = NULL;
	//EVP_PKEY *pkey = NULL;

	////s->data = s->p = NULL;
	////s->size = 0;

	//if (g_ssl == NULL)
	//	goto out;

	//cert = SSL_get_peer_certificate(g_ssl);
	//if (cert == NULL)
	//{
	//	__android_log_print(ANDROID_LOG_ERROR, "mySSL:", "tcp_tls_get_server_pubkey: SSL_get_peer_certificate() failed");
	//	goto out;
	//}

	//pkey = X509_get_pubkey(cert);
	//if (pkey == NULL)
	//{
	//	__android_log_print(ANDROID_LOG_ERROR, "mySSL:", "tcp_tls_get_server_pubkey: X509_get_pubkey() failed");
	//	goto out;
	//}

	////s->size = i2d_PublicKey(pkey, NULL);
	//if (/*s->size < 1*/0 < 1)
	//{
	//	__android_log_print(ANDROID_LOG_ERROR, "mySSL:", "tcp_tls_get_server_pubkey: i2d_PublicKey() failed");
	//	goto out;
	//}

	////s->data = s->p = xmalloc(s->size + 1);
	////i2d_PublicKey(pkey, &s->p);
	////s->end = s->p;

	//out:

	//if (cert)
	//	X509_free(cert);
	//if (pkey)
	//	EVP_PKEY_free(pkey);

	//(*env)->ReleaseByteArrayElements(env, data, s, 0);

	//__android_log_print(ANDROID_LOG_DEBUG, "mySSL:", "tls out...");
	return (1/*s->size != 0*/);
}

/*
 * Class:     com_test_ssl_mySSL
 * Method:    mySSLIsssl
 * Signature: ()Z
 */
JNIEXPORT jboolean JNICALL Java_com_test_ssl_mySSL_mySSLIsssl
  (JNIEnv *env, jclass c)
{
	if(g_ssl)
	{
		__android_log_print(ANDROID_LOG_DEBUG, "mySSL:", "ssl create true...");
		return 1;
	}
	else
	{
		__android_log_print(ANDROID_LOG_DEBUG, "mySSL:", "ssl create false...");
		return 0;
	}
}

/*
 * Class:     com_test_ssl_mySSL
 * Method:    mySSLclose
 * Signature: ()Z
 */
JNIEXPORT jboolean JNICALL Java_com_test_ssl_mySSL_mySSLclose
  (JNIEnv *env, jclass c)
{
	/*int err;
	err = SSL_shutdown(g_ssl);
	SSL_free(g_ssl);
	g_ssl = NULL;
	SSL_CTX_free(g_ssl_ctx);
	g_ssl_ctx = NULL;*/

	__android_log_print(ANDROID_LOG_DEBUG, "mySSL:", "ssl close...");
}


